# std::is_const

From cppreference.com
< cpp‎ | types

Defined in header `<type_traits>` |  |
template< class T > struct is_const; |  | (since C++11)

If `T` is a const-qualified type (that is, const, or const volatile), provides the member constant `value` equal true. For any other type, `value` is false.

### Template parameters

T | - | a type to check

### Helper variable template

template< class T > inline constexpr bool is_const_v = is_const<T>::value; |  | (since C++17)

## Inherited from std::integral_constant

### Member constants

value [static] | true if `T` is a const-qualified type , false otherwise (public static member constant)

### Member functions

operator bool | converts the object to bool, returns `value` (public member function)
operator() (C++14) | returns `value` (public member function)

### Member types

Type | Definition
`value_type` | `bool`
`type` | std::integral_constant<bool, value>

### Possible implementation

    template<class T> struct is_const          : std::false_type {};
    template<class T> struct is_const<const T> : std::true_type {};

### Example

Run this code

    #include <iostream>
    #include <type_traits>

    int main()
    {
        std::cout << std::boolalpha;
        std::cout << std::is_const<int>::value << '\n'; // false
        std::cout << std::is_const<const int>::value  << '\n'; // true
        std::cout << std::is_const<const int*>::value  << '\n'; // false
        std::cout << std::is_const<int* const>::value  << '\n'; // true
        std::cout << std::is_const<const int&>::value  << '\n'; // false
    }

Output:

    false
    true
    false
    true
    false

### See also

is_volatile (C++11) | checks if a type is volatile-qualified (class template)
as_const (C++17) | obtains a reference to const to its argument (function template)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/types/is_const&oldid=90972"